                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

/*------------------------------- public macros ------------------------------*/

#define Thread_Begin_Frame(SIGNATURE)                                          \
  Define_Grammar_Frame(SIGNATURE);                                             \
  typedef struct SIGNATURE {EXP_type bas[_Thread_Base_Size]

#define Thread_End_Frame(SIGNATURE)                                            \
  } SIGNATURE;                                                                 \
static const UNS_type SIGNATURE##_size                                         \
          = (sizeof(SIGNATURE)/sizeof(CEL_type) - _Thread_Base_Size)

#define Thread_Frame_Slot(SIGNATURE, NAME)                                     \
  SIGNATURE##_type NAME

/*------------------------------ hidden constants ----------------------------*/

enum { _Thread_Base_Size = 4 };
       
/*-------------------------------- public types ------------------------------*/

Define_Grammar_Frame(TPL);  /* opaque */

typedef THR_type * TRF_type;

/*------------------------------ public variables ----------------------------*/

extern THR_type Thread_Null;

/*------------------------------ public prototypes ---------------------------*/

NIL_type      Thread_Flush(TPL_type);
NBR_type     Thread_Get_Id(THR_type);
EXP_type   Thread_Get_Tail(THR_type);
THR_type     Thread_Keep_M(THR_type,
                           TPL_type);
THR_type     Thread_Make_M(NBR_type,
                           EXP_type,
                           UNS_type,
                           TPL_type);
NIL_type       Thread_Mark(THR_type);
THR_type    Thread_Patch_M(THR_type,
                           NBR_type,
                           TPL_type);
NIL_type       Thread_Poke(THR_type,
                           THR_type,
                           TPL_type);
UNS_type  Thread_Pool_Size(NIL_type);
NIL_type       Thread_Push(THR_type,
                           THR_type);
NIL_type    Thread_Release(THR_type,
                           TPL_type);
BYT_type Thread_Valid_Size(UNS_type);
TPL_type    Thread_Setup_M(NIL_type);
NIL_type        Thread_Zap(TRF_type,
                           TPL_type);
                           
/*----------------------------------------------------------------------------*/
                           
NIL_type Thread_Initialize(NIL_type);