                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*            environment            */
                     /*-----------------------------------*/

/*-------------------------------- public types ------------------------------*/

Define_Grammar_Frame(EPL);   /* opaque */

/*------------------------------ public variables ----------------------------*/

extern ENV_type Environment_Global_Environment;
extern FRM_type Environment_Global_Frame;

/*------------------------------ public prototypes ---------------------------*/

BYT_type Environment_Adjust_Global_Frame_C(UNS_type);
NIL_type  Environment_Confirm_Global_Frame(NIL_type);
NIL_type                 Environment_Flush(EPL_type);
UNS_type  Environment_Get_Environment_size(ENV_type);
EXP_type            Environment_Global_Get(ENV_type,
                                           UNS_type,
                                           UNS_type);                     
NIL_type            Environment_Global_Set(ENV_type,
                                           EXP_type,
                                           UNS_type,
                                           UNS_type);
NIL_type      Environment_Grow_Environment(ENV_type,
                                           ENV_type,
                                           FRM_type);
EXP_type             Environment_Local_Get(FRM_type,
                                           UNS_type);
NIL_type             Environment_Local_Set(EXP_type,
                                           FRM_type,
                                           UNS_type);
ENV_type                Environment_Make_M(UNS_type,
                                           EPL_type);
FRM_type          Environment_Make_Frame_M(UNS_type,
                                           EPL_type);
UNS_type             Environment_Pool_Size(NIL_type);
NIL_type         Environment_Release_Frame(FRM_type,
                                           EPL_type);
EPL_type               Environment_Setup_M(NIL_type);

/*----------------------------------------------------------------------------*/

NIL_type          Environment_Initialize_M(NIL_type);