                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*      version 14: multicores       */
                     /*-----------------------------------*/
                     /*               Slip                */
                     /*-----------------------------------*/

/*------------------------------ public constants ----------------------------*/

enum { AL1_error,
       AL2_error,
       ALO_error,
       AM1_error,
       AM2_error,
       ARN_error,
       BFO_error,
       BRQ_error,
       CRQ_error,
       DRQ_error,
       E1X_error,
       EX0_error,
       EX1_error,
       EX2_error,
       EX3_error,
       ICL_error,
       ILC_error,
       ILH_error,
       IMC_error,
       IMM_error,
       IOR_error,
       IPA_error,
       IRB_error,
       IRP_error,
       ITA_error,
       ITF_error,
       IUP_error,
       IVP_error,
       IVV_error,
       IXT_error,
       MRP_error,
       MSP_error,
       MSV_error,
       NAB_error,
       NAL_error,
       NAN_error,
       NAP_error,
       NAS_error,
       NAV_error,
       NNN_error,
       NTL_error,
       NTO_error,
       OPR_error,
       PEP_error,
       QRQ_error,
       TFO_error,
       TFX_error,
       TMO_error,
       TMR_error,
       TMT_error,
       TMX_error,
       TPO_error,
       VNF_error,
       XCT_error,
       PT1_error,
       PT2_error,
       PT3_error,
       PT4_error,
       PT5_error,
       PT6_error,
       PT7_error,
       PT8_error,
       PT9_error };

/*------------------------------ public callbacks ----------------------------*/

void  Slip_Error(short,
                 char*);
void   Slip_Fail(short);
void    Slip_Log(char*);
char*  Slip_Load(char*);
void  Slip_Print(char*);
char*  Slip_Read(void );

/*------------------------------ public prototypes ---------------------------*/

void Slip_REP(char*, int);